#include "screenmode.h"
#include "gba.h"
#include "colours.h"
#include "options.h"


// the ship colours - gba enhanced
static const unsigned short pal0[15] = {
  RGB16(8,31,11),   // planet 1 green
  RGB16(31,31,0),   // sun    2 yellow
  RGB16(31,31,31),  // white  3 white
  RGB16(0,31,31),   //        4  cyan
  RGB16(26,26,26),  //        5  grey
  RGB16(11,11,31),  //        6  blue
  RGB16(25,25,8),   //        7  dark yellow
  RGB16(31,10,10),  //        8  red
  RGB16(31,0,31),   //        9  purple
  RGB16(25,8,8),    //       10  dark red
  RGB16(8,25,8),    //       11  dark green
  RGB16(8,8,25),    //       12  dark blue
  RGB16(25,0,25),   //       13  dark purple
  RGB16(0,25,25),   //       14  dark cyan
  RGB16(21,21,21),  //       15  dark grey
};
// the ship colours
static const unsigned short pal1[15] = {
  RGB16(4,29,9),   // planet 1 green
  RGB16(31,31,0),   // sun    2 yellow
  RGB16(31,31,31),  // white  3 white
  RGB16(0,31,31),   //        4  cyan
  RGB16(25,25,25),  //        5  grey
  RGB16(0,0,31),    //        6  blue
  RGB16(21,21,0),   //        7  dark yellow
  RGB16(31,0,0),    //        8  red
  RGB16(31,0,31),   //        9  purple
  RGB16(19,0,0),    //       10  dark red
  RGB16(0,19,0),    //       11  dark green
  RGB16(0,0,19),    //       12  dark blue
  RGB16(19,0,19),   //       13  dark purple
  RGB16(0,19,19),   //       14  dark cyan
  RGB16(19,19,19),  //       15  dark grey
};
static const unsigned short pal2[15] = {
  RGB16(0x1f,0x1f,0x1f),  //1f
  RGB16(0x1e,0x1e,0x1e),  //1c
  RGB16(0x1d,0x1d,0x1d),  //1a
  RGB16(0x1c,0x1c,0x1c),  //18
  RGB16(0x1b,0x1b,0x1b),  //16
  RGB16(0x1a,0x1a,0x1a),  //14
  RGB16(0x19,0x19,0x19),  //12
  RGB16(0x18,0x18,0x18),  //10
  RGB16(0x17,0x17,0x17),  //0e
  RGB16(0x16,0x16,0x16),  //0c
  RGB16(0x15,0x15,0x15),  //0a
  RGB16(0x14,0x14,0x14),  //08
  RGB16(0x12,0x12,0x12),  //06
  RGB16(0x10,0x10,0x10),  //04
  RGB16(0x0e,0x0e,0x0e),  //02
};

#define PAL_CNT 3
static const unsigned short * const palettes[PAL_CNT] = {
  pal0,
  pal1,
  pal2,
};

void load_space_palette() {
  int i;
  int x = g_game_options.palette;
  if (x >= PAL_CNT)
   x = PAL_CNT-1; 
  for (i = 0; i < 15; i++) {
    BGPaletteMem[16*1 +1+ i] = palettes[x][i];
    BGPaletteMem[16*11 +1+ i] = palettes[0][i];
  }
  
}
