#ifndef options_h_seen
#define options_h_seen

typedef struct {
  unsigned char  instant_dock;
  unsigned char  polygons;
  signed char    palette;
  signed char    frame_rate;
  unsigned char  planet_solid;
  unsigned char  distant_objects;
  unsigned char  music_off; /* "Off" so that the default behaviour after upgrading is music on*/
} game_options_t;

#define OPTION_MUSIC     0x1
#define OPTION_SOUNDFX   0x2

#define DISTANT_OBJECTS_CROSS 1

extern game_options_t g_game_options;
extern const game_options_t default_options;

void game_options();
void set_default_options();
#endif
