
#ifndef shipdata_h_seen
#define shipdata_h_seen

#define BEACHBALL -4
#define CRATER -2
#define SUN -1

#define SHIP_MISSILE             0x01
#define SHIP_SST                 0x02
#define SHIP_CORIOLIS_STATION    0x02
#define SHIP_DODECAGON_STATION   0x02
#define SHIP_ESCAPE_CAPSULE      0x03
#define SHIP_ALLOY               0x04
#define SHIP_CARGO_CANNISTER     0x05
#define SHIP_BOULDER             0x06
#define SHIP_ASTEROID            0x07
#define SHIP_SPLINTER            0x08
#define SHIP_SHUTTLE             0x09
#define SHIP_TRANSPORTER         0x0A
#define SHIP_BOA                 0x0B
#define SHIP_GHAVIAL             0x0B
#define SHIP_COBRA_MK3           0x0B
#define SHIP_MONITOR             0x0B
#define SHIP_PYTHON              0x0B
#define SHIP_CHAMELEON           0x0C
// what is here??   0D
#define SHIP_ANACONDA            0x0E
#define SHIP_WORM                0x0F
#define SHIP_VIPER               0x10
#define SHIP_COBRA_MK1           0x11
#define SHIP_GECKO               0x11 
#define SHIP_KRAIT               0x12
#define SHIP_MAMBA               0x11
#define SHIP_SIDEWINDER          0x11
// what is here??   12
#define SHIP_ADDER               0x13
#define SHIP_IGUANA              0x13
#define SHIP_BUSHMASTER          0x14
#define SHIP_OPHIDIAN            0x15
#define SHIP_MORAY               0x16
// what is here??   17
// what is here??   18
#define SHIP_FER_DE_LANCE        0x19
// what is here??   1A
#define SHIP_ASP_MK2             0x1B 
// what is here??   1C
#define SHIP_THARGOID            0x1D
#define SHIP_THARGON             0x1E
#define SHIP_UNKOWN              0x1F

#ifdef HAVE_GBA_SHIPSETS
#define SHIP_HERMIT              0x20
#endif

/* these are taken from the encyclopedia 35EB
   ship "ids" for the various ship types...
;0x13,0x0e,0x1b,0x0b,0x14,0x0c,0x11,0x0b,
;0x02,0x02,0x03,0x19,0x11,0x0b,

;0x14,0x11,0x11,0x0b,0x16,0x15,0x0b,0x09,
;0x11,0x1d,0x1e,0x0a,0x10,0x0f
 
#define SHIP_ADDER               0x13
#define SHIP_ANACONDA            0x0E
#define SHIP_ASP_MK2             0x1B 
#define SHIP_BOA                 0x0B
#define SHIP_BUSHMASTER          0x14
#define SHIP_CHAMELEON           0x0C
#define SHIP_COBRA_MK1           0x11
#define SHIP_COBRA_MK3           0x0B
#define SHIP_CORIOLIS_STATION    0x02
#define SHIP_DODECAGON_STATION   0x02
#define SHIP_ESCAPE_CAPSULE      0x03
#define SHIP_FER_DE_LANCE        0x19
#define SHIP_GECKO               0x11 
#define SHIP_GHAVIAL             0x0B

#define SHIP_IGUANA              0x13
#define SHIP_KRAIT               0x11
#define SHIP_MAMBA               0x11
#define SHIP_MONITOR             0x0B
#define SHIP_MORAY               0x16
#define SHIP_OPHIDIAN            0x15
#define SHIP_PYTHON              0x0B
#define SHIP_SHUTTLE             0x09
#define SHIP_SIDEWINDER          0x11
#define SHIP_THARGOID            0x1D
#define SHIP_THARGON             0x1E
#define SHIP_TRANSPORTER         0x0A
#define SHIP_VIPER               0x10
#define SHIP_WORM                0x0F
 
#define SHIP_MISSILE             0x01

// ship data 7f00:
const vertex_t ship_missile_vertices[17] = {
  {    0,    0,   68,   31,  { 0,  1,  2,  3} }, 
  {    8,   -8,   36,   31,  { 1,  2,  4,  5} }, 
  {    8,    8,   36,   31,  { 2,  3,  4,  7} }, 
  {   -8,    8,   36,   31,  { 0,  3,  6,  7} }, 
  {   -8,   -8,   36,   31,  { 0,  1,  5,  6} }, 
  {    8,    8,  -44,   31,  { 4,  7,  8,  8} }, 
  {    8,   -8,  -44,   31,  { 4,  5,  8,  8} }, 
  {   -8,   -8,  -44,   31,  { 5,  6,  8,  8} }, 
  {   -8,    8,  -44,   31,  { 6,  7,  8,  8} }, 
  {   12,   12,  -44,    8,  { 4,  7,  8,  8} }, 
  {   12,  -12,  -44,    8,  { 4,  5,  8,  8} }, 
  {  -12,  -12,  -44,    8,  { 5,  6,  8,  8} }, 
  {  -12,   12,  -44,    8,  { 6,  7,  8,  8} }, 
  {   -8,    8,  -12,    8,  { 6,  7,  7,  7} }, 
  {   -8,   -8,  -12,    8,  { 5,  6,  6,  6} }, 
  {    8,    8,  -12,    8,  { 4,  7,  7,  7} }, 
  {    8,   -8,  -12,    8,  { 4,  5,  5,  5} }, 
}; // end of vertices
const line_t ship_missile_lines[24] = {
  { 31,   { 1,  2} , {   0,    1} },
  { 31,   { 2,  3} , {   0,    2} },
  { 31,   { 0,  3} , {   0,    3} },
  { 31,   { 0,  1} , {   0,    4} },
  { 31,   { 4,  2} , {   1,    2} },
  { 31,   { 1,  5} , {   1,    4} },
  { 31,   { 0,  6} , {   3,    4} },
  { 31,   { 3,  7} , {   2,    3} },
  { 31,   { 4,  7} , {   2,    5} },
  { 31,   { 4,  5} , {   1,    6} },
  { 31,   { 5,  6} , {   4,    7} },
  { 31,   { 6,  7} , {   3,    8} },
  { 31,   { 6,  8} , {   7,    8} },
  { 31,   { 7,  8} , {   5,    8} },
  { 31,   { 4,  8} , {   5,    6} },
  { 31,   { 5,  8} , {   6,    7} },
  {  8,   { 5,  8} , {   6,   10} },
  {  8,   { 7,  8} , {   5,    9} },
  {  8,   { 7,  8} , {   8,   12} },
  {  8,   { 5,  8} , {   7,   11} },
  {  8,   { 4,  7} , {   9,   15} },
  {  8,   { 4,  5} , {  10,   16} },
  {  8,   { 6,  7} , {  12,   13} },
  {  8,   { 5,  6} , {  11,   14} },
}; // end of lines
const face_t ship_missile_faces[9] = {
  {  -64,    0,   16,  31}, 
  {    0,  -64,   16,  31}, 
  {   64,    0,   16,  31}, 
  {    0,   64,   16,  31}, 
  {   32,    0,    0,  31}, 
  {    0,  -32,    0,  31}, 
  {  -32,    0,    0,  31}, 
  {    0,   32,    0,  31}, 
  {    0,    0, -176,  31}, 
}; // end of face norms
const shipheader_t ship_missile = {
  0, // 0  
  1576, // 1  
  ship_missile_vertices,
  ship_missile_lines,
  ship_missile_faces,
  81, // 5  
  0, // 6  
  10, // 7  
  17, // 8  
  24, // 9  
  0, // 10 
  0, // 11 
  9, // 12 
  14, // 13 
  2, // 14 
  44, // 15 
  2, // 18 
  0, // 19 
};
 
 */

/* global ship indices
#define GLOBAL_SHIP_CORIOLIS    0
#define GLOBAL_SHIP_ESCAPE_POD  1
#define GLOBAL_SHIP_ALLOY       2
#define GLOBAL_SHIP_OIL_DRUM    3
#define GLOBAL_SHIP_ROCK        4
#define GLOBAL_SHIP_???         5
#define GLOBAL_SHIP_ADDER       6
#define GLOBAL_SHIP_COBRA_MK1?  7
#define GLOBAL_SHIP_VIPER       8
#define GLOBAL_SHIP_GECKO       9
#define GLOBAL_SHIP_????        10
#define GLOBAL_SHIP_MORAY       11
#define GLOBAL_SHIP_DODEC       12
#define GLOBAL_SHIP_SHUTTLE_NEW 13
#define GLOBAL_SHIP_????        14
#define GLOBAL_SHIP_????        15
#define GLOBAL_SHIP_COBRA_MK3   16
#define GLOBAL_SHIP_IB_DB       17
#define GLOBAL_SHIP_?????       18
#define GLOBAL_SHIP_BUSHMASTER  19
#define GLOBAL_SHIP_?????       20
#define GLOBAL_SHIP_THARGOID    21
#define GLOBAL_SHIP_broken      22   tharglet??
#define GLOBAL_SHIP_?????       23
#define GLOBAL_SHIP_?????       24
#define GLOBAL_SHIP_asp?        25
#define GLOBAL_SHIP_???         26
#define GLOBAL_SHIP_ASTEROID    27
#define GLOBAL_SHIP_broken      28
#define GLOBAL_SHIP_????        29
#define GLOBAL_SHIP_broken      30
#define GLOBAL_SHIP_??????      31
#define GLOBAL_SHIP_??????      32
#define GLOBAL_SHIP_KRAIT       33
#define GLOBAL_SHIP_COBRA_MK1   34
#define GLOBAL_SHIP_????????    35
#define GLOBAL_SHIP_broken      36
#define GLOBAL_SHIP_SHUTTLE     37
#define GLOBAL_SHIP_broken      38
#define GLOBAL_SHIP_broken      39
#define GLOBAL_SHIP_???????     40
#define GLOBAL_SHIP_VIPER_again 41
#define GLOBAL_SHIP_???????     42
#define GLOBAL_SHIP_???????     44
#define GLOBAL_SHIP_VIPER_again 44
#define GLOBAL_SHIP_ASP?        45
#define GLOBAL_SHIP_GECKO_again 46
#define GLOBAL_SHIP_???_repeat  47
#define GLOBAL_SHIP_???         48
#define GLOBAL_SHIP_CORA_MK3    49
#define GLOBAL_SHIP_CORA_MK1    50
#define GLOBAL_SHIP_broken      51
#define GLOBAL_SHIP_??????      52
#define GLOBAL_SHIP_??????      53
#define GLOBAL_SHIP_??????      54
#define GLOBAL_SHIP_VIPER       55
#define GLOBAL_SHIP_KRAIT       56
#define GLOBAL_SHIP_COBRA_MK1   57
#define GLOBAL_SHIP_COBRA_MK3   58
#define GLOBAL_SHIP_??????      59
#define GLOBAL_SHIP_??????      60
#define GLOBAL_SHIP_ADDER       61
#define GLOBAL_SHIP_            62
#define GLOBAL_SHIP_            63  (monster!)
#define GLOBAL_SHIP_            64
#define GLOBAL_SHIP_VIPER       65
#define GLOBAL_SHIP_KRAIT       66
#define GLOBAL_SHIP_            67
*/

typedef struct {
 int x;
 int y;
 int z;
 int vanishpoint;
 unsigned char faces[4];
}vertex_t;

typedef struct {
 int vanishpoint;
 unsigned char faces[2];
 unsigned char vertices[2];
}line_t;

typedef struct {
 int x, y, z;
 int vanishpoint;
}face_t;

typedef struct {
  const unsigned char * const verts; // pointer to array of vertices
  unsigned char count;
  unsigned char face; // which face normal to use
  unsigned char vanishpoint;
  unsigned char colour;
} polygon_t;

typedef struct {
  unsigned char cargo;  // high nibble = cargo when scooped, low nibble = cargo carrying
  unsigned short target_size;
  const vertex_t * const  vertices; // pointer to vertex array
  const line_t * const lines; // pointer to line array
  const face_t * const faces; // pointer to face array
  const polygon_t * const polys; // pointer to polygon arrays
  unsigned char max_lines; //5
  unsigned char laser_vertex; //6 maximum points stored for the ship
  char byte7;
  unsigned char vertex_count; // 8 vertex count * 6
  unsigned char line_count; // 9 absolute line count
  unsigned char bountylo;
  unsigned char bountyhi;
  unsigned char face_count;// 12 face normal count * 4
  unsigned char poly_count;// 12 face normal count * 4
  unsigned char size; // 13 mid.z value above which the ship is a dot, or "SHIP_SIZE"
  unsigned char max_energy;
  char max_speed;
  char shift;     //
  unsigned char arsenal;    // top 5 bits are the laser strength, low 3 are missile count
  unsigned char name;   // encylopedia name 
  unsigned short kill_value; // NES kill value

} shipheader_t;



//extern const shipheader_t * ships[];
#ifdef HAVE_GBA_SHIPSETS
typedef struct{
  int length;
  const shipheader_t *const ships[];
} ship_collection_t;
extern const ship_collection_t * const ship_collections[];
const unsigned char ship_flags[32][2];
extern const shipheader_t * ships [34];
extern unsigned char current_ship_flags[34];
#else
extern const shipheader_t *const *const  ship_collections[23];
const unsigned char * ship_flags[23];
extern const shipheader_t *const * ships;
extern const unsigned char * current_ship_flags;
#endif
#endif
