#ifndef soundfx_h_seen
#define soundfx_h_seen

#define SOUND_MASTER_ENABLE    BIT07
#define SOUND_OUTPUT_FULL      BIT01
#define SOUND_LENGTH(n)        n
#define DUTY_CYCLE(n)          (n<<6)

#define SOUND1_SG10_H           (SOUND_LENGTH(0x8) | DUTY_CYCLE(2))
#define SOUND2_SG20             (SOUND_LENGTH(0x8) | DUTY_CYCLE(2))

#define SOUND3BANK64          0x0020    // Use one bank of 64 steps
#define SOUND3PLAY            0x0080    // Output sound
#define SOUND3OUTPUT1         0x2000    // Output unmodified
#define SOUND3OUTPUT14        0x6000    // Output 1/4 
#define SOUND3SETBANK1        0x0040
#define SOUND3SETBANK0        0x0000

#define SOUND3_SG30_H             (SOUND_LENGTH(0x10) | SOUND3OUTPUT1)
#define SOUND4_SG40               ( SOUND_LENGTH(0x10) )

// each sound effect is a table of these values: 
typedef struct 
{
  unsigned short freq;
  unsigned short volume;
  unsigned short count;
} soundentry_t;

typedef struct 
{
  const soundentry_t * sound_data;
  int length;  // how many entries there are
  int channel; // which channel to play it in (0-3, 3 being noise)
} elitesfx_t;

extern const elitesfx_t g_elite_soundfx[];

#define SOUNDFX_ENEMY_FIRE     0
#define SOUNDFX_ERROR_PING     1
#define SOUNDFX_LAUNCH         2
#define SOUNDFX_LASER_PLAYER   3
#define SOUNDFX_PURCHASE       4
#define SOUNDFX_UNARM_MIS      5
#define SOUNDFX_TARGET_MIS     6
#define SOUNDFX_ECM            7
#define SOUNDFX_EXPLOSION      8
#define SOUNDFX_HYPERSPACE     9
#define SOUNDFX_JUMP_LOCK      10
#define SOUNDFX_LAUNCH_MISSILE 11
#define SOUNDFX_CRUNCH         12
#define SOUNDFX_FIT_LASER      13
#define SOUNDFX_EQUIP_SHIP     14
#define SOUNDFX_MENU_CLICK     15
#define SOUNDFX_MENU_ACCEPT    16
#define SOUNDFX_WARNING        17
#define SOUNDFX_TRUMBLE        18
#define SOUNDFX_SCOOP        19

#include "sxmp.h"
#include "modules.h"
void init_sound();
void play_sound(int id);
void sound_ir();
void play_song(int id); 
#endif
