
#ifndef universe_h_seen
#define universe_h_seen

#include "motion.h"
#define NUM_SHIPS  12
#define MAX_SHIP_ID  31

#if USE_MALLOC
extern stellarobject_t * g_objects;
extern int * g_object_types;
#else
extern stellarobject_t g_objects[NUM_SHIPS];
extern int g_object_types[MAX_SHIP_ID];
#endif
//extern int g_dangerous_ships;
void zero_objects(void);
int add_new_ship(int shipid);
int copy_to_new_ship(int type, stellarobject_t * parent);
void init_universe(void);
void update_universe(void);
void add_station(void);
void add_planet(void);
void  generate_random_location(stellarobject_t * obj);
void  clear_ship_counts(void);

// load a particular ship set - used when reloading saved game
void do_load_shipset(int * set);

void load_shipset(void);
int damage_ship(int ship, int damage);
void increment_kills(int );
#endif

