#ifndef upgrade_h_seen
#define upgrade_h_seen
/*
          L1 L2 L3 L4 LN MC EN EU SP CG FL EQ TG  name      price
   004747 0e 8e 92 19 02 02 04 01 24 09 3c 1a df  ADDER         310000
          0e 8f 93 19 04 03 05 01 2d 0a 46 1a ef  GECKO         400000 
          10 8f 96 19 04 03 06 01 26 0c 50 68 ef  MORAY         565000
          0e 8e 94 19 04 04 05 01 27 0f 3c 1a cf  COBRA MK1     750000 
          0e 8e 94 19 04 04 07 01 32 16 4b 00 df  IGUANA       1315000
          0d 8d 90 0c 01 03 04 01 33 19 46 68 ff  OPHIDIAN     1470000
          10 8f 97 32 02 04 08 01 2b 24 50 68 df  CHAMELEON    2250000
          12 8f 98 32 04 05 07 01 2a 2b 46 00 ef  COBRA MK3    2870000
          12 92 9c 32 04 04 08 02 2d 0a 55 34 df  FER-DE-LANCE 3595000
          11 90 99 32 04 04 09 01 25 38 50 00 cf  GHAVIAL      3795000
          18 93 9c 32 04 09 0a 01 18 52 6e 4e bf  MONITOR      5855000
          18 92 9b 32 04 05 0b 01 1e 6b 50 1a af  PYTHON       7620000
          14 8e 98 32 02 07 0a 01 24 85 5a 00 bf  BOA          9600000
          10 91 9f 0c 01 02 0a 01 3c 07 7d 34 df  ASP MK2     10120000
          1c 90 7f 32 04 11 0d 01 15 fe 64 4e af  ANACONDA    18695000
*/
#define SHIPDATA_LASER_MINING 3
typedef struct {
  // first data is 0xd bytes at 4684
  //char name[10];
  unsigned char  name;   // use encyclo2buffer to write this
  unsigned short price;  // divided by 1000

  // nextdata is 0xd bytes at 4747
  unsigned char laser_strength[4]; // 03D0 - 03D3
  unsigned char laser_mounts;   // 03D4
  unsigned char missile_count;  // 03D5
  unsigned char hull_strength;  // 03D6 subtracted from some damages 
  unsigned char regen_rate;     // 03D7 energy += regen_rate every frame
  unsigned char max_speed;      // 03D8
  unsigned char total_cargo;    // 03D9
  unsigned char max_fuel;       // 03DA
  unsigned char equipment_cost;       // 03DB?
  unsigned char turning_circle;    // 03DC
  
} player_ship_t;
extern const player_ship_t player_ship_data[15];

void print_ship_name(int i);
void buy_ship(void);
void equip_ship(void);
void sell_ship_equipment(void);

void show_equipment(int,int);
void equipment_screen();

#endif
