#include <stdlib.h>
#include <string.h>
#include "gba.h"
#include "screenmode.h"
#include "keypad.h"
#include "gbahandler.h"
#include "universe.h"
#include "options.h"
#include "commander.h"
#include "gfx.h"
#include "input.h"
#include "scrolltext.h"
#include "autopilot.h"
#include "stars.h"
#include "eliteloop.h"
#include "tactics.h"
#include "upgrade.h"
#include "script.h"
#include "loadsave.h"
#include "sprite.h"
#include "text.h"
#include "soundfx.h"

#include "modules.h"
#include "sxmp.h"

int g_need_combat_seq=0;
void combat_sequence() {
  // I don't know how the NES version does this, 
  // but this seemed fairly logical to me...
#ifdef  HAVE_GBA_SHIPSETS
  load_shipset();
  ships[SHIP_WORM-1] = ship_collections[SHIP_WORM-1]->ships[0];
  ships[SHIP_ADDER-1] = ship_collections[SHIP_ADDER-1]->ships[0];
  ships[SHIP_KRAIT-1] = ship_collections[SHIP_KRAIT-1]->ships[3];
#else
  ships = ship_collections[3];
#endif
  
  add_planet();
  g_objects[0].location.x = 0x060000;
  add_new_ship(SUN);
  g_objects[1].location.y = 0x060000;

  g_my_stats.screen = SCR_LAUNCHED;
  g_my_stats.docked = 0;
  g_my_stats.combat_seq = 1;

  extern const shipheader_t shiplogo;
  const shipheader_t * const data = &shiplogo;
  initialise_scripted_ships();
  int cont=1;
  while (cont) {
    wait_vsync_int();
    if (game_frames < 2)
      continue;
    game_frames = 0;
    swap_buffer();
    clear_screen();
    update_stars(0);
    entry(&g_objects[NUM_SHIPS-1], data);
    cont = !fly_script_ships();
  }
  REG_DISPCNT |= BG1_ENABLE;
  show_crosshair(g_commander.equipment[g_my_stats.view]);
  set_missile_count(g_commander.equipment[MISSILES]);


#if 0
  g_objects[2].missiles |= REMOVE_OBJECT;
  g_objects[3].missiles |= REMOVE_OBJECT;
  g_objects[4].missiles |= REMOVE_OBJECT;
#endif
  g_key_handler = user_flight_controls;
  g_timer_fn = space_screen;
  // this 'spins' until we get killed or kill everyone
  main_loop();

  g_my_stats.combat_seq = 0;
  /*
  while (1) {
    wait_vsync_int();
    UpdateKeys();
    if (KeyPressed(KEY_A) || KeyPressed(KEY_START)) {
      break;
    }
  }*/

}

void time2a(int time,char * tmp) {
  int2a(time,tmp);
  if (time < 10) {
    char t = tmp[0];
    tmp[0]='0';
    tmp[1]=t;
    tmp[2]=0;
  }
}
void congratulate()
{
  char str[64];
  str[0] = 0;
  strcat(str,"CONGRATULATIONS!;YOU;COMPLETED;;THE:TRAINING:IN:;");
  char tmp[3];
  time2a(g_my_stats.time.minute,tmp);  
  strcat(str,tmp);
  strcat(str,";MIN;");
  time2a(g_my_stats.time.second,tmp);  
  strcat(str,tmp);
  strcat(str,";SEC;");
  
  do_scroll_text(str);
  
  do_scroll_text(
  "\
;YOU;BEGIN;YOUR;\
CAREER;DOCKED;AT\
;THE;PLANET;LAVE\
WITH;500;CREDITS\
"); 
  do_scroll_text(
  "\
;;;GOOD;LUCK,;;;\
::::::::::::::::\
;;;COMMANDER.;;");
;
  
}

void flying_logo() {
  sxmp_fade_out();
  screen_fade_out();
  set_default_options();
  g_my_stats = default_stats;
  restore_commander(&default_commander);
  g_commander.ship = 7;
  g_commander.equipment[FRONT_LASER] = player_ship_data[g_commander.ship].laser_strength[1];
  g_commander.equipment[MISSILES] = 3;
  g_commander.equipment[ECM_SYSTEM] = 1;
  g_commander.fuel = 0;
  g_commander.cargo_space--;
  player_alpha = player_beta = 0;
  g_alpha = g_beta = g_delta = 0;
  zero_objects();
  init_bgs();
  CopyOAM();
  // clear out the scanner (replace with basic frame)
  REG_DISPCNT &= ~BG1_ENABLE;

  
  stellarobject_t * obj = &g_objects[NUM_SHIPS-1];
  // normals are set such that only these rotations look ok
  obj->location.x = 0;
  obj->location.y = -100;
  obj->location.z = 0x96;
  obj->rotmat[2].z = 0x6000;

  screen_fade_in();
  sxmp_fake_stereo(0);
  play_song(SONG_ELITE_MISSION);
#if 1
  do_scroll_text(";;;;QUIRKY;;;;;;::::::::::::::::;;;PRESENTS...");
  int z;
  extern const shipheader_t shiplogo;
  const shipheader_t * const data = &shiplogo;
  game_frames = 0;
  // move from 'behind' us to a position just in front
  for (z = 0x64; z > 0; z--) {
    obj->location.z+=3;
    wait_vsync_int();
    if (game_frames < 2)
      continue;
    game_frames = 0;
    swap_buffer();
    clear_screen();
    update_stars(0);
    entry(obj, data);
    UpdateKeys();
  }
  // rotate to face us
  while (obj->rotmat[2].z >0) {
    obj->location.z+=2;
    obj->location.y+=2;
    fixed_rotate(&obj->rotmat[1].x,&obj->rotmat[2].x,0x80);
    fixed_rotate(&obj->rotmat[1].y,&obj->rotmat[2].y,0x80);
    fixed_rotate(&obj->rotmat[1].z,&obj->rotmat[2].z,0x80);
    wait_vsync_int();
    if (game_frames < 2)
      continue;
    game_frames = 0;
    swap_buffer();
    clear_screen();
    update_stars(0);
    entry(obj, data);
    //update_stars(1);
    UpdateKeys();
  }
  
#endif
  combat_sequence();
  if (g_my_stats.game_over == 2) {
    congratulate();
    g_my_stats.game_over = 0;
    screen_fade_out();
  }
  g_my_stats.docked = 1;
  restore_commander(&default_commander);
}
